'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\nmutation login (\n  $email: String!\n  $password: String!\n) {\n  passportLoginEmail (\n    email: $email\n    password: $password\n  ) {\n    error\n    token\n    userId\n  }\n}\n'], ['\nmutation login (\n  $email: String!\n  $password: String!\n) {\n  passportLoginEmail (\n    email: $email\n    password: $password\n  ) {\n    error\n    token\n    userId\n  }\n}\n']);

var _graphqlTag = require('graphql-tag');

var _graphqlTag2 = _interopRequireDefault(_graphqlTag);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

// check and warn if regenerator-runtime not installed / present

var mutation = (0, _graphqlTag2.default)(_templateObject);

var ApolloPassport = function () {
  function ApolloPassport(_ref) {
    var apolloClient = _ref.apolloClient;

    _classCallCheck(this, ApolloPassport);

    this.apolloClient = apolloClient;

    this._subscribers = new Set();

    this._token = localStorage.getItem('apToken');
    this._userId = localStorage.getItem('apUserId');
    this._verified = false;

    if (this._token) this.assertToken();
  }

  _createClass(ApolloPassport, [{
    key: 'assertToken',
    value: function assertToken() {}
  }, {
    key: 'loginWithEmail',
    value: function loginWithEmail(email, password) {
      var result, queryResult;
      return regeneratorRuntime.async(function loginWithEmail$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return regeneratorRuntime.awrap(this.apolloClient.mutate({
                mutation: mutation,
                variables: { email: email, password: password }
              }));

            case 2:
              result = _context.sent;


              // if error...

              queryResult = result.data.passportLoginEmail;

              if (!queryResult.error) {
                _context.next = 6;
                break;
              }

              throw new Error(queryResult.error);

            case 6:

              localStorage.setItem('apToken', queryResult.token);
              localStorage.setItem('apUserId', queryResult.userId);
              this._userId = queryResult.userId;

              this.emitState();

            case 10:
            case 'end':
              return _context.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: 'signupWithEmail',
    value: function signupWithEmail(email, password) {}
  }, {
    key: 'getState',
    value: function getState() {
      return {
        userId: this._userId,
        verified: this._verified
      };
    }
  }, {
    key: 'subscribe',
    value: function subscribe(callback) {
      this._subscribers.add(callback);
    }
  }, {
    key: 'unsubscribe',
    value: function unsubscribe(callback) {
      this._subscribers.delete(callback);
    }
  }, {
    key: 'emitState',
    value: function emitState() {
      var state = this.getState();
      this._subscribers.forEach(function (callback) {
        return callback(state);
      });
    }

    // if it's not reactive does this make any sense?

  }, {
    key: 'userId',
    value: function userId() {
      return this._userId;
    }
  }, {
    key: 'logout',
    value: function logout() {
      localStorage.removeItem('apToken');
      localStorage.removeItem('apUserId');
      delete this._userId;

      this.emitState();
    }
  }]);

  return ApolloPassport;
}();

exports.default = ApolloPassport;