'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LoginButtonsNative = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function bindValues(obj, that) {
  var out = {};
  for (var key in obj) {
    out[key] = obj[key].bind(that);
  }return out;
}

var LoginButtonsUI = function LoginButtonsUI(_ref) {
  var state = _ref.state;
  var actions = _ref.actions;
  return _react2.default.createElement(
    'div',
    null,
    state.userId ? _react2.default.createElement(
      'div',
      { onClick: actions.logout },
      'Log Out from ',
      state.userId
    ) : _react2.default.createElement(
      'div',
      { onClick: actions.login },
      'Log In'
    )
  );
};

LoginButtonsUI.propTypes = {
  state: _react.PropTypes.object,
  actions: _react.PropTypes.object
};

var LoginButtonsNativeActions = {
  login: function login() {
    this.apolloPassport.loginWithEmail('test@test.com', 'x');
  },
  logout: function logout() {
    this.apolloPassport.logout();
  }
};

var LoginButtonsNative = function (_Component) {
  _inherits(LoginButtonsNative, _Component);

  function LoginButtonsNative(_ref2) {
    var apolloPassport = _ref2.apolloPassport;

    _classCallCheck(this, LoginButtonsNative);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(LoginButtonsNative).call(this));

    _this.actions = bindValues(LoginButtonsNativeActions, _this);
    _this.apolloPassport = apolloPassport;

    _this.apStateHandler = function apStateHandler(state) {
      this.setState(state);
    }.bind(_this);

    _this.state = apolloPassport.getState();
    apolloPassport.subscribe(_this.apStateHandler);
    return _this;
  }

  _createClass(LoginButtonsNative, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.apolloPassport.unsubscribe(this.apStateHandler);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(LoginButtonsUI, { state: this.state, actions: this.actions });
    }
  }]);

  return LoginButtonsNative;
}(_react.Component);

exports.LoginButtonsNative = LoginButtonsNative;