'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
// This file is only used for testing, will work with cirlceci in future

var host = process.env.RETHINKDB_HOST || '127.0.0.1';
var port = process.env.RETHINKDB_PORT || 28015;

var r = require('rethinkdbdash')({
  db: "test",
  servers: [{ host: host, port: port }]
});

function freshUserTable() {
  return regeneratorRuntime.async(function freshUserTable$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.prev = 0;
          _context.next = 3;
          return regeneratorRuntime.awrap(r.tableDrop('users').run());

        case 3:
          _context.next = 9;
          break;

        case 5:
          _context.prev = 5;
          _context.t0 = _context['catch'](0);

          if (!(_context.t0.msg !== 'Table `test.users` does not exist.')) {
            _context.next = 9;
            break;
          }

          throw _context.t0;

        case 9:
          _context.prev = 9;
          _context.next = 12;
          return regeneratorRuntime.awrap(r.tableCreate('users').run());

        case 12:
          _context.next = 18;
          break;

        case 14:
          _context.prev = 14;
          _context.t1 = _context['catch'](9);

          if (!(_context.t1.msg !== 'Table `test.users` already exists.')) {
            _context.next = 18;
            break;
          }

          throw _context.t1;

        case 18:
        case 'end':
          return _context.stop();
      }
    }
  }, null, this, [[0, 5], [9, 14]]);
}

exports.freshUserTable = freshUserTable;
exports.default = r;