'use strict';

var _chai = require('chai');

var _chai2 = _interopRequireDefault(_chai);

require('regenerator-runtime/runtime');

var _rethinkdbdash = require('../../../../db/rethinkdbdash');

var _rethinkdbdash2 = _interopRequireDefault(_rethinkdbdash);

var _rethinkdbdashInstance = require('../../../../db/rethinkdbdash-instance');

var _rethinkdbdashInstance2 = _interopRequireDefault(_rethinkdbdashInstance);

var _verify2 = require('./verify');

var _verify3 = _interopRequireDefault(_verify2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var should = _chai2.default.should();

describe('Strategies - local - db - rethinkdbdash - verify', function () {

  var context = {};
  var verify = _verify3.default.bind(context);
  var db = context.db = new _rethinkdbdash2.default(_rethinkdbdashInstance2.default, "users");

  before(function _callee() {
    return regeneratorRuntime.async(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return regeneratorRuntime.awrap((0, _rethinkdbdashInstance.freshUserTable)());

          case 2:
            _context.next = 4;
            return regeneratorRuntime.awrap(db.users.insert([{
              id: "user1",
              emails: [{ address: "test@test.com" }]
            }]).run());

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, null, undefined);
  });

  it('finds a user by email and verifies password', function (done) {

    verify("test@test.com", "test123", function (err, user) {
      user.id.should.equal("user1");
      done();
    });
  });

  it('should fail on no matching email', function (done) {

    verify("non-existing-email", "test123", function (err, user) {
      should.equal(user, false);
      done();
    });
  });
});